// Activator.h : header file
//

#ifndef __ACTIVATOR_H
#define __ACTIVATOR_H

#include <string>

class CActivator  
{
public:
    CActivator(BSTR bstrURI, BSTR bstrMethod);
    virtual ~CActivator() {}

	// Invokes the appropriate method and returns a DOM response
    virtual void Invoke(IXMLDOMDocument *pRequest, IXMLDOMDocument **ppResponse);

protected:
	// Protected helper functions...note the response packet assumes
	// a single return value (no [out] params to return)...
	void CreateResponse(IXMLDOMDocument *pResponse, const std::string& strReturn);
	void CreateFault(IXMLDOMDocument *pResponse, HRESULT hrErr);

protected:
	// URI and method of object to be activated
    CComBSTR m_bstrMethodURI;
    CComBSTR m_bstrMethod;
};

#endif // __ACTIVATOR_H
