// SOAPBody.cpp
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP Body object implementation
//

// Disable the "truncated to 255 characters" warning
// when expanding STL templates...
#pragma warning(disable : 4786)

#include "SOAPBody.h"
#include "SOAPEnvelope.h"

CSOAPBody::CSOAPBody(CSOAPEnvelope* pEnvelope, CSOAPHeader* pHeader /*=NULL*/) :
  CSOAPScopingElement(BODYBASECOOKIE,pEnvelope),
  m_pEnvelope(pEnvelope),
  m_pHeader(pHeader)
{
	// Establish tag text
	SetTagText("Body");
	SetTagNamespace(ENVNSCOOKIE);
}

CSOAPBody::~CSOAPBody()
{
}
