// SOAPBody.h
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP Body object definition
//
#if !defined __SOAPBODY_H
#define __SOAPBODY_H

#include "SOAPScopingElement.h"

#define BODYBASECOOKIE	0x00040000

class CSOAPEnvelope;
class CSOAPHeader;
class CSOAPBody : public CSOAPScopingElement
{
public:
	CSOAPBody(CSOAPEnvelope* pEnvelope, CSOAPHeader* pHeader = NULL);
	virtual ~CSOAPBody();

// Methods
public:
	CSOAPEnvelope* GetEnvelope() { return m_pEnvelope; }
	CSOAPHeader* SetHeader(CSOAPHeader* pHeader) {
		CSOAPHeader* pHeaderTemp = m_pHeader;
		m_pHeader = pHeader;
		return pHeaderTemp;
	}
	CSOAPHeader* GetHeader() { return m_pHeader; }

// Attributes
protected:
	CSOAPEnvelope* m_pEnvelope;
	CSOAPHeader* m_pHeader;

};

#endif // __SOAPBODY_H