// SOAPElementAttributes.h
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP XML element attribute object definition
//
#if !defined __SOAPELEMENTATTRIBUTES_H
#define __SOAPELEMENTATTRIBUTES_H

#include <vector>
#include <string>
#include <iostream>
#include <strstream>

// Standard attribute cookies
#define GLOBATTRCOOKIE		-1
#define ENCATTRCOOKIE		0
#define MUNDATTRCOOKIE		1
#define ACTNXTATTRCOOKIE	2
#define ROOTATTRCOOKIE		3

// Fwd declaration
class CSOAPElement;

class CSOAPElementAttributes
{
public:
	CSOAPElementAttributes(CSOAPElement* pParent = NULL);
	virtual ~CSOAPElementAttributes();

// Methods
public:
	bool EnableStdAttribute(long iStdAttributeCookie, bool bEnable);
	unsigned long InsertAttribute(long iNamespaceCookie, std::string& strAttrName, std::string& strAttrValue);
	unsigned long WriteToStream(std::ostrstream& ostr);

	void SetParent(CSOAPElement* pNewParent) { m_pParent = pNewParent; }
	CSOAPElement* GetParent() { return m_pParent; }

protected:
	unsigned long StreamStdAttribute(std::ostrstream& ostr, long iStdAttributeCookie);

// Attributes
protected:
	CSOAPElement* m_pParent;

	bool m_bStdAttributes[4];
	std::vector<std::string> m_vecAttributes;

};

#endif // __SOAPELEMENTATTRIBUTES_H