// SOAPEnvelope.h
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP Envelope object definition
//
#if !defined __SOAPENVELOPE_H
#define __SOAPENVELOPE_H

#include <iostream>
#include <strstream>
#include "SOAPScopingElement.h"

#define ENVELOPEBASECOOKIE	0x00010000

class CSOAPHeader;
class CSOAPBody;
class CSOAPHttpPacket;
class CSOAPEnvelope : public CSOAPScopingElement
{
public:
	CSOAPEnvelope(CSOAPHttpPacket* pParent);
	virtual ~CSOAPEnvelope();

// Methods
public:
	virtual unsigned long InsertElement(const std::string& strTagText, long iNamespaceCookie, CSOAPElement** ppElement);
	virtual unsigned long WriteToStream(std::ostrstream& ostr);
	virtual unsigned long StreamOpenTag(std::ostrstream& ostr);
	virtual unsigned long StreamCloseTag(std::ostrstream& ostr);
	CSOAPHttpPacket* GetHttpPacket() { return m_pParent; }
	CSOAPHeader* GetHeader();
	CSOAPBody* GetBody() { return m_pBody; }

// Attributes
protected:
	CSOAPHttpPacket* m_pParent;
	CSOAPHeader* m_pHeader;
	CSOAPBody* m_pBody;

};

#endif // __SOAPENVELOPE_H