// SOAPIndElement.h
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP independent element object definition
//
#if !defined __SOAPINDELEMENT_H
#define __SOAPINDELEMENT_H

#include <vector>
#include <string>
#include <iostream>
#include <strstream>
#include "SOAPElement.h"

class CSOAPEmbeddedElement;
class CSOAPIndElement : public CSOAPElement
{
public:
	CSOAPIndElement(CSOAPElement* pParent);
	virtual ~CSOAPIndElement();

// Methods
public:
	virtual unsigned long InsertElement(const std::string& strTagText, long iNamespaceCookie, CSOAPEmbeddedElement** ppElement);
	virtual unsigned long StreamContents(std::ostrstream& ostr);
	virtual unsigned long StreamOpenTag(std::ostrstream& ostr);
	virtual unsigned long StreamCloseTag(std::ostrstream& ostr);

// Attributes
protected:
	std::vector<CSOAPEmbeddedElement*> m_vecElements;
};

#endif // __SOAPINDELEMENT_H