// SOAPScopingElement.h
//
// Kenn Scribner
// Understanding SOAP, March 2000
//
// SOAP scoping element object definition
//
#if !defined __SOAPSCOPINGELEMENT_H
#define __SOAPSCOPINGELEMENT_H

#include <vector>
#include <string>
#include <iostream>
#include <strstream>
#include "SOAPElement.h"

class CSOAPIndElement;
class CSOAPScopingElement : public CSOAPElement
{
public:
	CSOAPScopingElement(long iBaseNSCookie, CSOAPElement* pParent = NULL);
	virtual ~CSOAPScopingElement();

// Methods
public:
	virtual unsigned long InsertElement(const std::string& strTagText, long iNamespaceCookie, CSOAPIndElement** ppElement);
	virtual unsigned long StreamContents(std::ostrstream& ostr);
	virtual unsigned long StreamOpenTag(std::ostrstream& ostr);
	virtual unsigned long StreamCloseTag(std::ostrstream& ostr);

// Attributes
protected:
	std::vector<CSOAPIndElement*> m_vecElements;

};

#endif // __SOAPSCOPINGELEMENT_H