// VCDSoapClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDSoapClient.h"
#include "VCDSoapClientDlg.h"

#include "..\SOAPObjectLib\SOAPEnvelope.h"
#include "..\SOAPObjectLib\SOAPHeader.h"
#include "..\SOAPObjectLib\SOAPBody.h"
#include "..\SOAPObjectLib\SOAPIndElement.h"
#include "..\SOAPObjectLib\SOAPEmbeddedElement.h"

#include <strstream>
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDSoapClientDlg dialog

CVCDSoapClientDlg::CVCDSoapClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDSoapClientDlg::IDD, pParent),
	m_dwTimerID(-1),
	m_bActive(FALSE)
{
	//{{AFX_DATA_INIT(CVCDSoapClientDlg)
	m_strHost = _T("http://www.yourhosthere.com/VCDSoap/VCDSoapExtension.dll");
	m_strResult = _T("");
	m_bContinuous = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVCDSoapClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDSoapClientDlg)
	DDX_Text(pDX, IDC_HOSTTEXT, m_strHost);
	DDX_Text(pDX, IDC_RESULTTXT, m_strResult);
	DDX_Check(pDX, IDC_CONTINUOUS, m_bContinuous);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDSoapClientDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDSoapClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REQUEST, OnRequestTime)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CONTINUOUS, OnContinuous)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDSoapClientDlg message handlers

BOOL CVCDSoapClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Set the focus to the host text
	CWnd* pCtrl = GetDlgItem(IDC_HOSTTEXT);
	pCtrl->SetFocus();
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CVCDSoapClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDSoapClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDSoapClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCDSoapClientDlg::OnContinuous() 
{
	// Toggle between continuous mode and one-shot mode
	UpdateData(TRUE);

	m_bActive = FALSE;
	m_dwTimerID = -1;
	CWnd* pButton = GetDlgItem(IDC_REQUEST);
	ASSERT(pButton != NULL);
	if ( m_bContinuous ) {
		// Begin continuous operations...
		pButton->SetWindowText(_T("&Start"));
	} // if
	else {
		// Terminate continuous operations...
		pButton->SetWindowText(_T("&Request Time"));
	} // else
}

void CVCDSoapClientDlg::OnRequestTime()
{
	// Check state of checkbox to see which way to go...
	UpdateData(TRUE);

	if ( m_bContinuous ) {
		// Obtain control pointers for UI work...
		CWnd* pRequest = GetDlgItem(IDC_REQUEST);
		ASSERT(pRequest != NULL);
		CWnd* pContinuous = GetDlgItem(IDC_CONTINUOUS);
		ASSERT(pContinuous != NULL);

		// Check system state...
		if ( m_bActive ) {
			// We're currently active, so turn off the system,
			// reset the button text, and enable the checkbox...
			m_bActive = FALSE;
			KillTimer(m_dwTimerID);
			m_dwTimerID = -1;
			pRequest->SetWindowText(_T("&Start"));
			pContinuous->EnableWindow(TRUE);
		} // if
		else {
			// We're currently inactive, so turn on the system,
			// set the button text, and disable the checkbox...
			m_dwTimerID = SetTimer(1,250,NULL);
			ASSERT(m_dwTimerID);
			m_bActive = TRUE;
			pRequest->SetWindowText(_T("&Stop"));
			pContinuous->EnableWindow(FALSE);
		} // else
	} // if
	else {
		// Single-shot mode...
		MakeRequest();
	} // else
}

void CVCDSoapClientDlg::OnTimer(UINT nIDEvent) 
{
	// Call the base class...
	CDialog::OnTimer(nIDEvent);

	// Stop the timer for a moment...
	KillTimer(m_dwTimerID);
	m_dwTimerID = -1;

	// Make the request...note that if the request
	// is not successful, we break the loop...
	if ( MakeRequest() ) {
		// Start the timer...
		m_dwTimerID = SetTimer(1,250,NULL);
		ASSERT(m_dwTimerID);
	} // if
	else {
		// Some SOAP error, so deactivate...
		m_bActive = FALSE;

		// Reset the request button
		CWnd* pCtrl = GetDlgItem(IDC_REQUEST);
		ASSERT(pCtrl != NULL);
		pCtrl->SetWindowText(_T("&Start"));

		// Enable the checkbox
		pCtrl = GetDlgItem(IDC_CONTINUOUS);
		ASSERT(pCtrl != NULL);
		pCtrl->EnableWindow(TRUE);
	} // else
}

BOOL CVCDSoapClientDlg::MakeRequest() 
{
	BOOL bSucceeded = FALSE;
	CSOAPHttpPacket* pPacket = NULL;

	try {
		// Create a SOAP packet
		SOAPCALLINFO ciInfo;
		ciInfo.strHost = m_strHost;
		ciInfo.strPostHdr = "VCDSoapRequest";
		ciInfo.strActionData = "www.yourhosthere.com#GetRemoteTime";
		ciInfo.strMethod = "GetRemoteTime";
		pPacket = new CSOAPHttpPacket(&ciInfo);
		
		// Retrieve the envelope
		CSOAPEnvelope* pEnvelope = pPacket->GetEnvelope();
		if ( !pEnvelope ) throw IDS_E_NOENVELOPE;

		// Enable the standard stuff...
		pEnvelope->EnableStdAttribute(ENCATTRCOOKIE,true);

		// Insert the namespace...
		long iCookie = NULLNSCOOKIE;
		HRESULT hr = pEnvelope->InsertNamespace(std::string("www.yourhosthere.com"),std::string("m"),&iCookie);
		if ( FAILED(hr) ) throw IDS_E_NOENVELOPENS;

		// Next insert the method's independent element into the
		// body
		CSOAPBody* pBody = pEnvelope->GetBody();
		CSOAPIndElement* pMethodElement = NULL;
		hr = pBody->InsertElement(ciInfo.strMethod,iCookie,&pMethodElement);
		if ( FAILED(hr) ) throw IDS_E_NOINSMETHOD;

		// Fire off the message
		CComBSTR bstrResponse;
		if ( SUCCEEDED(SendReceive(pPacket,bstrResponse)) ) {
			// Stuff the response into an instance of the XML parser...
			CComPtr<IXMLDOMDocument> spResponseXMLDoc;
			hr = spResponseXMLDoc.CoCreateInstance(__uuidof(DOMDocument));
			if ( FAILED(hr) ) throw hr;

			VARIANT_BOOL bSuccess = false;
			hr = spResponseXMLDoc->loadXML(bstrResponse,&bSuccess);
			if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
			if ( !bSuccess ) throw IDS_E_NORESPONSE;

			// Pull the time string by looking for a particular
			// node (the correctly-formatted response node):
			//
			// Check for <SOAP-ENV:Envelope>
			//              <SOAP-ENV:Body>
			//                 <m:ShowTimeResponse>
			//                    <return>...
			//
			// Construct search string
			//  "SOAP-ENV:Envelope/SOAP-ENV:Body/m:ShowTimeResponse/return"
			std::string strSS("SOAP-ENV:Envelope/SOAP-ENV:Body/");
			strSS += _T("m:");
			strSS += _T("GetRemoteTimeResponse");
			strSS += _T("/return");
			CComBSTR bstrSS(strSS.c_str());
			CComPtr<IXMLDOMNode> spResponse;
			hr = spResponseXMLDoc->selectSingleNode(bstrSS,&spResponse);
			if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
			if ( spResponse.p != NULL ) {
				// Pull the node's value
				CComVariant var;
				hr = spResponse->get_nodeTypedValue(&var);
				if ( FAILED(hr) ) throw IDS_E_NORESPONSE;

				// Assign the value
				USES_CONVERSION;
				CComBSTR bstrVal(var.bstrVal);
				LPTSTR strVal = W2T(bstrVal);

				// Show the result...let's parse out some of
				// the information and rearrange to make a 
				// more user-friendly display...
				LPTSTR strYear = _tcstok(strVal,_T("-"));
				LPTSTR strMonth =  _tcstok(NULL,_T("-"));
				LPTSTR strDay =  _tcstok(NULL,_T("T"));
				LPTSTR strTime =  _tcstok(NULL,_T("-+\0"));
				LPTSTR strBias =  _tcstok(NULL,_T("\0"));

				m_strResult.Format("%s, %s/%s/%s (%s)",strTime,strMonth,strDay,strYear,strBias!=NULL?strBias:_T("UTC"));
				UpdateData(FALSE);

				// Set return value
				bSucceeded = TRUE;
			} // if
			else {
				// SOAP fault?  Let's parse it and see...
				// Check for <SOAP-ENV:Envelope>
				//              <SOAP-ENV:Body>
				//                 <SOAP-ENV:Fault>
				//
				// Construct search string
				//  "SOAP-ENV:Envelope/SOAP-ENV:Body/SOAP-ENV:Fault"
				std::string strSS("SOAP-ENV:Envelope/SOAP-ENV:Body/SOAP-ENV:Fault");
				CComBSTR bstrSS(strSS.c_str());
				CComPtr<IXMLDOMNode> spFaultNode;
				HRESULT hr = spResponseXMLDoc->selectSingleNode(bstrSS,&spFaultNode);
				if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
				if ( spFaultNode.p != NULL ) {
					// Pull the faultcode's value
					strSS = "faultcode";
					bstrSS = strSS.c_str();
					CComPtr<IXMLDOMNode> spFaultCodeNode;
					CComVariant varFaultCode;
					hr = spFaultNode->selectSingleNode(bstrSS,&spFaultCodeNode);
					if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
					if ( spFaultCodeNode.p != NULL ) {
						// Get faultcode string
						hr = spFaultCodeNode->get_nodeTypedValue(&varFaultCode);
						if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
					} // if

					// Pull the faultstring's value
					strSS = "faultstring";
					bstrSS = strSS.c_str();
					CComPtr<IXMLDOMNode> spFaultStringNode;
					CComVariant varFaultString;
					hr = spFaultNode->selectSingleNode(bstrSS,&spFaultStringNode);
					if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
					if ( spFaultStringNode.p != NULL ) {
						// Get faultstring string
						hr = spFaultStringNode->get_nodeTypedValue(&varFaultString);
						if ( FAILED(hr) ) throw IDS_E_NORESPONSE;
					} // if

					// Assign the values
					USES_CONVERSION;
					CComBSTR bstrFaultCode(varFaultCode.bstrVal);
					LPTSTR strFaultCode = W2T(bstrFaultCode);

					CComBSTR bstrFaultString(varFaultString.bstrVal);
					LPTSTR strFaultString = W2T(bstrFaultString);

					// Show the fault...
					LPTSTR strFault = _tcstok(strFaultCode,_T("."));
					LPTSTR strSubFault =  _tcstok(NULL,_T("\0"));

					m_strResult = _T("(SOAP Fault)");
					UpdateData(FALSE);

					// Show the result
					CString strMsg;
					strMsg.Format("Fault: \"%s\"\nSubfault: \"%s\"\nFault string: \"%s\"",strFault,strSubFault,strFaultString);
					MessageBox(strMsg,"SOAP Fault Error",MB_OK|MB_ICONERROR);
				} // if
			} // else
		} // if
	} // try
	catch(int iErrIndex) {
		// Use the provided error index as a string table
		// lookup offset
		CString strMsg;
		strMsg.LoadString(iErrIndex);
		MessageBox(strMsg,"SOAP Application Error",MB_OK|MB_ICONERROR);
	}
	catch(...) {
		// Generic error
		MessageBox("Error sending and/or receiving SOAP information","SOAP Application Error",MB_OK|MB_ICONERROR);
	} // catch

	// Clean up...
	if ( pPacket != NULL ) {
		delete pPacket;
		pPacket = NULL;
	} // if

	return bSucceeded;
}

HRESULT CVCDSoapClientDlg::SendReceive(CSOAPHttpPacket* pPacket, CComBSTR& bstrResponse)
{
	// Check the pointer
	if ( pPacket == NULL ) return E_POINTER;

	HRESULT hr = S_OK;
	try {
		// Create the HTTP request object
		CComPtr<IXMLHttpRequest> spRequest;
		hr = spRequest.CoCreateInstance(__uuidof(XMLHTTPRequest));
		if ( FAILED(hr) ) throw hr;

		// Open the connection to the remote host
		std::string strHost;
		pPacket->GetHostText(strHost);
		hr = spRequest->open(CComBSTR("POST"),
							 CComBSTR(strHost.c_str()),
							 CComVariant(FALSE),
							 CComVariant(VT_BSTR),
							 CComVariant(VT_BSTR));
		if ( FAILED(hr) ) throw hr;

		// Set up the HTTP headers
		std::string strData;
		pPacket->GetPostText(strData);
		hr = spRequest->setRequestHeader(CComBSTR("POST"),CComBSTR(strData.c_str()));
		if ( FAILED(hr) ) throw hr;

		hr = spRequest->setRequestHeader(CComBSTR("HOST"),CComBSTR(strHost.c_str()));
		if ( FAILED(hr) ) throw hr;

		pPacket->GetContentTypeText(strData);
		hr = spRequest->setRequestHeader(CComBSTR("Content-Type"),CComBSTR(strData.c_str()));
		if ( FAILED(hr) ) throw hr;

		pPacket->GetSoapActionText(strData);
		hr = spRequest->setRequestHeader(CComBSTR("SOAPAction"),CComBSTR(strData.c_str()));
		if ( FAILED(hr) ) throw hr;

		// Create an instance of the XML parser, which is used to
		// ship the SOAP document to the remote host.
		CComPtr<IXMLDOMDocument> spRequestXMLDoc;
		hr = spRequestXMLDoc.CoCreateInstance(__uuidof(DOMDocument));
		if ( FAILED(hr) ) throw hr;

		// Get XML (SOAP) document
		std::ostrstream ostr;
		pPacket->WriteToStream(ostr,true);
		CComBSTR bstrRequest(ostr.pcount()+1,ostr.str());
		ostr.freeze(0); // allows deletion of character stream upon destruction

		VARIANT_BOOL bSuccess = false;
		hr = spRequestXMLDoc->loadXML(bstrRequest,&bSuccess);
		if ( FAILED(hr) ) throw hr;
		if ( !bSuccess ) throw E_UNEXPECTED;

		// Send the information to the remote host
		CComQIPtr<IDispatch> spXMLDisp;
		spXMLDisp = spRequestXMLDoc;
		hr = spRequest->send(CComVariant(spXMLDisp));
		if ( FAILED(hr) ) throw hr;

		// Get the status code from the response
		long iStatus = 0;
		hr = spRequest->get_status(&iStatus);
		if ( FAILED(hr) ) throw hr;

		// Check the status code for "200"
		if ( iStatus != 200 ) {
			// An HTTP error...
			throw iStatus;
		} // if

		// Get the response as a string and return it
		hr = spRequest->get_responseText(&bstrResponse);
		if ( FAILED(hr) ) throw hr;
	} // try
	catch(HRESULT hrErr) {
		// Bad HRESULT
		CComPtr<IErrorInfo> spIErrorInfo;
		hr = GetErrorInfo(0,&spIErrorInfo);
		if ( spIErrorInfo.p != NULL ) {
			CComBSTR bstrDesc;
			spIErrorInfo->GetDescription(&bstrDesc);
			USES_CONVERSION;
			MessageBox(W2T(bstrDesc),"SOAP Application Error",MB_OK|MB_ICONERROR);
		} // if
		else {
			// No error object, so fake it...
			MessageBox("Error processing the SOAP request/response","SOAP Application Error",MB_OK|MB_ICONERROR);
		} // else

		hr = hrErr;
	} // catch
	catch(...) {
		// Generic error
		MessageBox("Unknown error processing the SOAP request/response","SOAP Application Error",MB_OK|MB_ICONERROR);
	} // catch

	return hr;
}

void CVCDSoapClientDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// If the timer is going, stop it...
	if ( m_dwTimerID != -1 ) {
		KillTimer(m_dwTimerID);
		m_dwTimerID = -1;
	} // if
}
